#!/usr/bin/python3.4
# -*-coding:Utf-8 -*
import math
from  tkinter import *
from tkinter.messagebox import *
from CurEdit import *#importe la classe du fichier local CurEdit.py
from math import *
import os


class Interface(LabelFrame):
	"""fenêtre principale"""
	
	def __init__(self, fenetre, **kwargs):
		LabelFrame.__init__(self, fenetre,text="Diagramme d'impédance pour une charge RLC série", borderwidth=2, relief=GROOVE, **kwargs)
		self.pack(side=LEFT, padx=10, pady=10)

		#  taille de l'écran
		self.h = int(self.winfo_screenheight() * 0.7)
		self.w = int(self.h*4/3)
		# Création de nos widgets
		self.message = Label(self, text="Clic gauche : zoom avant       Clic droit : zoom arrière")
		
		#  initialisations
		self.OrigineX = int(self.w/10)
		self.OrigineY = int(self.h/2)
		self.echelle = 1.0
		self.signe = 1
		
		#  dessin
		self.dessin = Canvas(self, width=self.w, height=self.h, background='white')
		self.schema = PhotoImage(file='RLC.png')
		self.image = self.dessin.create_image(self.w - 199, self.h - 56, image=self.schema)
		self.axe_im = self.dessin.create_line(self.OrigineX, 0, self.OrigineX, self.h, arrow='first', arrowshape = '15 20 5', fill='black',width=1)
		self.axe_reel = self.dessin.create_line(0, self.OrigineY, self.w, self.OrigineY, arrow='last', arrowshape = '15 20 5', fill='black',width=1)
		#  self.horiz = self.dessin.create_line(0, self.OrigineY, self.w, self.OrigineY, dash=(4,4), fill='black',width=1)
		#  self.vertic = self.dessin.create_line(0, self.OrigineY, self.w, self.OrigineY,  dash=(4,4), fill='black',width=1)
		
		self.ligne_r = self.dessin.create_line(self.OrigineX, self.OrigineY, 240, self.OrigineY, arrow='last', arrowshape = '20 30 8', fill='blue',width=3)
		self.ligne_l = self.dessin.create_line(self.OrigineX, self.OrigineY, 300, 60, arrow='last', arrowshape = '20 30 8', fill='red',width=2)
		self.ligne_C = self.dessin.create_line(240, self.OrigineY, 300, 60, arrow='last', arrowshape = '20 30 8', fill='green', width=2)
		self.ligne_z = self.dessin.create_line(240, self.OrigineY, 300, 60, arrow='last', arrowshape = '15 20 5', dash=(4,4), fill='black', width=2)

		self.txtR = self.dessin.create_text(75, 60, text="R", font="Arial 16", fill="blue")
		self.txtL = self.dessin.create_text(75, 60, text="ZL", font="Arial 16 underline", fill="red")
		self.txtC = self.dessin.create_text(75, 60, text="ZC", font="Arial 16 underline", fill="green")
		self.txtZ = self.dessin.create_text(75, 60, text="Z", font="Arial 14 underline", fill="black")
		self.txtO = self.dessin.create_text(self.OrigineX - 20, self.OrigineY +20, text="O", font="Arial 14", fill="black")

		self.txtDecrochage = self.dessin.create_text(400, 60, text="", font="Arial 18", fill="red")

		self.dessin.bind('<Button-1>', self.zoom)
		self.dessin.bind('<Button-3>', self.zoom)

		#  zone de réglages et de mesures
		self.reglages = PanedWindow(self, orient=VERTICAL)
		
		frame_RLC = Frame(self.reglages, pady = 10)
		#  ligne de définition de R
		self.R_val = IntVar()
		CB_R_val = Checkbutton(frame_RLC, text='', variable=self.R_val)
		self.R_val.trace('w', self.case_changee)

		label_R = Label(frame_RLC, text = 'R', fg='blue', font='Arial, 12', pady=5)

		self.val_R = DoubleVar()
		self.C_R = CurseurEditable(self.reglages, valeur=self.val_R, titre="Résistance", nom=' R ', min=0.0, max=300.0,
								   resol=1, couleur='blue', unit='Ω')
		self.val_R.trace("w", self.tracer)  # si R est changé ça déclenche le tracé

		#  ligne de définition de L
		self.L_val = IntVar()
		CB_L_val = Checkbutton(frame_RLC, text='', variable=self.L_val)
		self.L_val.trace('w', self.case_changee)

		label_L = Label(frame_RLC, text='L', fg='red', font='Arial, 12', pady=5)

		self.val_L = DoubleVar()
		self.C_L = CurseurEditable(self.reglages, valeur=self.val_L, titre="Inductance", nom=' L ', min=0.0, max=300.0,
								   resol=1, couleur='red', unit='mH')
		self.val_L.trace("w", self.tracer)  # si L est changé ça déclenche le tracé

		#  ligne de définition de C
		self.C_val = IntVar()
		CB_C_val = Checkbutton(frame_RLC, text='', variable=self.C_val)
		self.C_val.trace('w', self.case_changee)

		label_C = Label(frame_RLC, text='C', fg='green', font='Arial, 12', pady=5)

		self.val_C = DoubleVar()
		self.C_C = CurseurEditable(self.reglages, valeur=self.val_C, titre="Capacité", nom=' C ', min=0.0, max=300.0,
								   resol=1, couleur='green', unit='µF')
		self.val_C.trace("w", self.tracer)  # si C est changé ça déclenche le tracé

		#  Curseur de f
		self.val_f = DoubleVar()
		self.C_f = CurseurEditable(self.reglages, valeur=self.val_f, titre="Fréquence", nom=' f ', min=0.0, max=300.0,
								   resol=1, couleur='black', unit='Hz')
		self.val_f.trace("w", self.tracer)  # si f est changé ça déclenche le tracé

		CB_R_val.grid(row=1, column=1)
		label_R.grid(row=1, column=2)
		CB_L_val.grid(row=2, column=1)
		label_L.grid(row=2, column=2)
		CB_C_val.grid(row=3, column=1)
		label_C.grid(row=3, column=2)

		self.aff1 = Label(self, text = 'Z = 0Ω', fg='black', font='Arial, 12', bg='#eeeeee', pady=5)# ancienne c6b6dd
		self.aff2 = Label(self, text = 'ArgZ = 0°', fg='black', font='Arial, 12', bg='#eeeeee', pady=5)
		self.aff3 = Label(self, text='ZL = Lω = ---Ω', fg='red', font='Arial, 12', bg='#eeeeee', pady=5)  # ancienne c6b6dd
		self.aff4 = Label(self, text='ZC = 1/Cω = ---Ω', fg='green', font='Arial, 12', bg='#eeeeee', pady=5)

		self.reglages.add(frame_RLC)
		self.reglages.add(self.C_R)
		self.reglages.add(self.C_L)
		self.reglages.add(self.C_C)
		self.reglages.add(self.C_f)

		self.reglages.add(self.aff1, pady=10)
		self.reglages.add(self.aff2, pady=10)
		self.reglages.add(self.aff3, pady=10)
		self.reglages.add(self.aff4, pady=10)

		#  pack!
		self.reglages.pack(side="left")
		self.message.pack()
		self.dessin.pack()

		#  initialisation des variables
		self.init = True  #  permet de ne pas tracer tant que tout n'est pas ficé
		self.C_R.set(30)
		self.C_L.set(100)
		self.C_C.set(50)
		self.C_f.set(50)

		self.R_val.set(True)
		self.L_val.set(True)
		self.C_val.set(True)
		self.init = False
		self.echelle = 3.0
		self.tracer()

	def case_changee(self, *args):
		if not self.R_val.get():
			self.C_R.disable()
		else:
			self.C_R.enable()
		if not self.L_val.get():
			self.C_L.disable()
		else:
			self.C_L.enable()
		if not self.C_val.get():
			self.C_C.disable()
		else:
			self.C_C.enable()
		self.tracer()

	def zoom(self, event):
		if event.num == 1: self.echelle = self.echelle + 0.2  #  bouton gauche zoome
		if event.num == 3: self.echelle = self.echelle - 0.2  #  bouton droit dézoome
		self.tracer()
		
	def eValide(self, event):
		"""on a tapé entrée dans Entry_L ou f"""
		if event.keysym == "Return" or event.keysym == "KP_Enter": self.tracer()

	def tracer(self, *args): #  la mention *args permet d'accepter tous les arguments de l'évennement traité
		"""Tracé du diagramme."""

		if not self.init:
			try:
				omega = float(self.val_f.get()) * 2 * pi
				R = self.val_R.get()
				self.dessin.itemconfig(self.txtDecrochage, text='')
				if self.L_val.get():
					ZL = float(self.val_L.get()) * omega / 1000.0
					self.aff3['text'] = "ZL = Lω = {:2.2f} Ω".format(ZL)
					self.dessin.itemconfig(self.ligne_l, state='normal')
					self.dessin.itemconfig(self.txtL, state='normal')
				else:
					ZL = 0.0
					self.aff3['text'] = "ZL = Lω = --- Ω"
					self.dessin.itemconfig(self.ligne_l, state='hidden')
					self.dessin.itemconfig(self.txtL, state='hidden')

				if self.C_val.get():
					ZC = 1 / float(self.val_C.get()) / omega * 1e6
					self.aff4['text'] = "ZC = 1/Cω = {:2.2f} Ω".format(ZC)
					self.dessin.itemconfig(self.ligne_C, state='normal')
					self.dessin.itemconfig(self.txtC, state='normal')
				else:
					ZC = 0.0
					self.aff4['text'] = "ZC = 1/Cω = --- Ω"
					self.dessin.itemconfig(self.ligne_C, state='hidden')
					self.dessin.itemconfig(self.txtC, state='hidden')

				if self.R_val.get():
					phi = atan((ZL-ZC)/R)
					self.dessin.itemconfig(self.ligne_r, state='normal')
					self.dessin.itemconfig(self.txtR, state='normal')
				else:
					phi = math.copysign(1.571, ZL - ZC)
					R = 0.0
					self.dessin.itemconfig(self.ligne_r, state='hidden')
					self.dessin.itemconfig(self.txtR, state='hidden')
				Z = sqrt(R ** 2 + (ZL - ZC) ** 2)

				self.aff1.configure(text = "Z = {:2.2f} Ω".format(Z), fg = 'black')
				self.aff2['text'] = "φ = {:3.0f} °".format(phi * 180.0 / pi)

				xR = self.OrigineX + R * self.echelle
				yR = self.OrigineY
				xL = xR
				yL = self.OrigineY - ZL * self.echelle
				xC = xR
				yC = yL + ZC * self.echelle

				#  tracé
				if self.R_val.get(): self.dessin.coords(self.ligne_r, self.OrigineX, self.OrigineY, xR, yR)
				self.dessin.coords(self.ligne_l, xR-1, yR, xL-1, yL)
				self.dessin.coords(self.ligne_C, xL+1, yL, xC+1, yC)
				self.dessin.coords(self.ligne_z, self.OrigineX, self.OrigineY, xC, yC)

				self.dessin.coords(self.txtR, self.OrigineX + (xR - self.OrigineX)/2, yR+20)
				self.dessin.coords(self.txtL, xL + 20, yL)
				self.dessin.coords(self.txtC, xC - 20, yC)
				self.dessin.coords(self.txtZ, self.OrigineX + (xR - self.OrigineX)/2 - 10, self.OrigineY + (yC - self.OrigineY)/2)

			except ValueError:
				t = Toplevel(self)
				Label(t, text="Il faut entrer un nombre.").pack(padx=5, pady=5)
				Button(t, text="Ok", command=t.destroy).pack(padx=5, pady=5)
			except ZeroDivisionError:
				self.dessin.itemconfig(self.txtDecrochage, text='Ne pas entrer de valeur nulle !')


if __name__ != "__main__":
	pass
else:
	fen=Tk()
	fen['bg'] = 'white'
	fen.title("Diagramme d'impédance P. Philip 2023")
	MonInter = Interface(fen)

	MonInter.mainloop()

